#include <windows.h>
#include <stdio.h>

#define MAX_THREAD	5
#define MAX_MESSAGE_LEN	128

HANDLE hStdOut;	/* handle di standard output */

DWORD WINAPI MyThread(LPVOID lpVoid)
{
	CHAR szMessage[MAX_MESSAGE_LEN];
	DWORD dwThreadId;
	DWORD dwSleepTime;
	DWORD dwBytesWritten;

	dwThreadId = GetCurrentThreadId(); /* ottiene l'id del thread */
	dwSleepTime = *(LPDWORD)lpVoid; /* il parametro indica il tempo da aspettare in secondi */
	
	Sleep(dwSleepTime * 1000);

	/* Riempie il buffer szMessage con la stringa ...*/
	wsprintf(szMessage, "Ciao dal thread %d dopo %d secondi\n", dwThreadId, dwSleepTime);

	/* ... scrive la stringa su standard output */
	WriteFile(hStdOut, szMessage, strlen(szMessage), &dwBytesWritten, NULL);
	
	return 0;
}

void main()
{
	DWORD i;
	HANDLE hThread[MAX_THREAD];
	DWORD dwSleepTime[MAX_THREAD];
	
	hStdOut = GetStdHandle(STD_OUTPUT_HANDLE); /* ottiene l'handle di standard output */
	
	for(i = 0; i < MAX_THREAD; ++i)
	{
		dwSleepTime[i] = i; /* secondi che il thread i-esimo deve attendere prima di scrivere su stdout */
		hThread[i] = CreateThread(NULL, 0, MyThread, &dwSleepTime[i], 0, NULL);
	}
 	
	/* attende che tutti i thread abbiano terminato l'esecuzione*/
	WaitForMultipleObjects(MAX_THREAD, hThread, TRUE, INFINITE);

	for(i = 0; i < MAX_THREAD; ++i)
		CloseHandle(hThread[i]);

	CloseHandle(hStdOut);
}
